#define GEN_ALL_KEYS "/apps/compiz/general/allscreens/options/"
#define GEN_KEYS "/apps/compiz/general/screen0/options/"
#define DECO_KEYS "/apps/compiz/plugins/decoration/allscreens/options/"
#define CUBE_ALL_KEYS "/apps/compiz/plugins/cube/allscreens/options/"
#define CUBE_KEYS "/apps/compiz/plugins/cube/screen0/options/"
#define FADE_KEYS "/apps/compiz/plugins/fade/screen0/options/"
#define CUBE_DESC "/apps/compiz/plugins/cube/long_descrition"
#define MINI_KEYS "/apps/compiz/plugins/minimize/screen0/options/"
#define MOVE_ALL_KEYS "/apps/compiz/plugins/move/allscreens/options/"
#define PLACE_KEYS "/apps/compiz/plugins/place/screen0/options/"
#define RESIZE_ALL_KEYS "/apps/compiz/plugins/resize/allscreens/options/"
#define ROTATE_ALL_KEYS "/apps/compiz/plugins/rotate/allscreens/options/"
#define ROTATE_KEYS "/apps/compiz/plugins/rotate/screen0/options/"
#define SCALE_ALL_KEYS "/apps/compiz/plugins/scale/allscreens/options/"
#define SCALE_KEYS "/apps/compiz/plugins/scale/screen0/options/"
#define SWITCH_ALL_KEYS "/apps/compiz/plugins/switcher/allscreens/options/"
#define SWITCH_KEYS "/apps/compiz/plugins/switcher/screen0/options/"
#define WOBBLY_ALL_KEYS "/apps/compiz/plugins/wobbly/allscreens/options/"
#define WOBBLY_KEYS "/apps/compiz/plugins/wobbly/screen0/options/"
#define ZOOM_ALL_KEYS "/apps/compiz/plugins/zoom/allscreens/options/"
#define ZOOM_KEYS "/apps/compiz/plugins/zoom/screen0/options/"
#define TRAIL_KEYS "/apps/compiz/plugins/trailfocus/screen0/options/"
#define WATER_ALL_KEYS "/apps/compiz/plugins/water/allscreens/options/"
#define MINIWIN_KEYS "/apps/compiz/plugins/miniwin/screen0/options/"
#define DOCK_KEYS "/apps/compiz/plugins/dock/screen0/options/"
#define BS_KEYS "/apps/compiz/plugins/bs/screen0/options/"
#define STATE_KEYS "/apps/compiz/plugins/state/screen0/options/"

#define VERSION 		"0.3.4" 

/* path to novel.png and icon.png, ... */
#define DEF_IMAGE_FOLDER 	"/usr/share/compiz"

typedef struct {
	const gchar *name; 	/* the widget name  */
	gchar *dir;		/* gconf path       */
	gchar *key;		/* gconf key        */
	guint type;		/* the widget type  */
} items;


void get_gconf_keys (void);

void set_gconf_keys (void);

void active_plugins (void);
GtkTreeModel *active_plugins_store (GtkListStore *);
void set_active_plugins (void);

gint *compare (gconstpointer, gconstpointer);

void wobbly_fx_types (void);
GtkTreeModel *populate_wobbly_fx (GtkListStore *);
void set_wobbly_fx (void);

void choose_window_types (void);
GtkTreeModel *create_window_store (GtkListStore *);
void set_window_store (void);

void slide_preview_size (GtkComboBox *, GPtrArray *);

void update_preview (GtkFileChooser *, gpointer);

void choose_corner_list (void);
GtkTreeModel *create_corner_store (GtkListStore *);
void set_corner_store (void);

void images_list (void);
GtkTreeModel *create_top_image_store (void);
GtkTreeModel *create_bottom_image_store (void);
void set_image_store (guint *);

void image_position_changed (GtkComboBox *, GPtrArray *);

void trailfocus_list (void);
GtkTreeModel *create_trailfocus_store (GtkListStore *);
void set_trailfocus_store (void);

void state_list (void);
GtkTreeModel *create_state_store (GtkListStore *);
void set_state_store (void);

void set_sensitivity (void);

void select_X_window (void);

GdkFilterReturn filter (GdkXEvent *, GdkEvent *, GtkWidget *);

void set_wm_class (gchar *, GtkWidget *);

void *gconf_error_handling (GConfClient *, GError *);

void file_error_handling (GError *);

int X_error (Display *, XErrorEvent *);

void toolbutton_short (GtkButton *, gpointer);

void toolbutton_plug (GtkButton *, gpointer);

void select_image_button (GtkButton *, gpointer);

void value_changed (GtkEditable *, gpointer);

void own_config (void);

void change_version (gboolean);

void file_open (GtkButton *, gpointer);

gchar *check_file_path (gchar *);
